function Button(){
	this.width = 50
	this.height = 20;
	this.vOffset = 0;
	this.hOffset = 0;
	this.visible = 0;
	this.label = "";

	this.imageSrc = "Objects/Button";

	this.buttonFrame = new Frame();
	this.buttonFrame.visible = this.visible;
	this.buttonFrame.width = this.width;
	this.buttonFrame.height = this.height;

	this.unvMouseDown = function(){
		this.left.src = this.imageSrc+"/buttondownleft.png";
		this.center.src = this.imageSrc+"/buttondowncenter.png";
		this.right.src = this.imageSrc+"/buttondownright.png";
		}

	this.unvMouseUp = function(){
		this.left.src = this.imageSrc+"/buttonupleft.png";
		this.center.src = this.imageSrc+"/buttonupcenter.png";
		this.right.src = this.imageSrc+"/buttonupright.png";
		}
		
	this.onMouseUp = function(){}
	this.onMouseDown = function(){}
	
	this.onDragEnter = function(){}
	this.onDragExit = function(){}
	this.onDragDrop = function(){}
	
	this.left = new Image()
	this.left.parent = this;
	this.left.src = this.imageSrc+"/buttonupleft.png";
	this.left.width = 5;
	this.left.height = this.height;
	this.left.vOffset = 0;
	this.left.hOffset = 0;
	this.left.onMouseUp = function(){this.parent.unvMouseUp(); this.parent.onMouseUp();}
	this.left.onMouseDown = function(){this.parent.unvMouseDown(); this.parent.onMouseDown();}
	this.left.onDragEnter = function(){this.parent.unvMouseDown();this.parent.onDragEnter();}
	this.left.onDragExit = function(){this.parent.unvMouseUp();this.parent.onDragExit();}
	this.left.onDragDrop = function(){this.parent.onDragDrop();}

	this.center = new Image()
	this.center.parent = this;
	this.center.src = this.imageSrc+"/buttonupcenter.png";
	this.center.width = this.width-10;
	this.center.height = this.height;
	this.center.vOffset = 0;
	this.center.hOffset = 5;
	this.center.onMouseUp = function(){this.parent.unvMouseUp(); this.parent.onMouseUp();}
	this.center.onMouseDown = function(){this.parent.unvMouseDown(); this.parent.onMouseDown();}
	this.center.onDragEnter = function(){this.parent.unvMouseDown();this.parent.onDragEnter();}
	this.center.onDragExit = function(){this.parent.unvMouseUp();this.parent.onDragExit();}
	this.center.onDragDrop = function(){this.parent.onDragDrop();}

	this.right = new Image()
	this.right.parent = this;
	this.right.src = this.imageSrc+"/buttonupright.png";
	this.right.width = 5;
	this.right.height = this.height;
	this.right.vOffset = 0;
	this.right.hOffset = 5+this.center.width;
	this.right.onMouseUp = function(){this.parent.unvMouseUp(); this.parent.onMouseUp();}
	this.right.onMouseDown = function(){this.parent.unvMouseDown(); this.parent.onMouseDown();}
	this.right.onDragEnter = function(){this.parent.unvMouseDown();this.parent.onDragEnter();}
	this.right.onDragExit = function(){this.parent.unvMouseUp();this.parent.onDragExit();}
	this.right.onDragDrop = function(){this.parent.onDragDrop();}
	
	this.labelText = new Text();
	this.labelText.alignment = "center";
	this.labelText.data = this.label;
	this.labelText.size = 12;
	this.labelText.font = "Verdana";
	this.labelText.hOffset = this.buttonFrame.width / 2;
	this.labelText.vOffset = this.labelText.size + 2;
	this.labelText.color = "#000000";
	
	this.buttonFrame.addSubview(this.left);
	this.buttonFrame.addSubview(this.center);
	this.buttonFrame.addSubview(this.right);
	this.buttonFrame.addSubview(this.labelText);
	
	this.attach = function(newParent){newParent.addSubview(this.buttonFrame)}
	
	this.watch("height", function(id, oldval, newval){this.buttonFrame.height = newval; this.left.height = newval; this.center.height = newval; this.right.height = newval; return newval;})
	this.watch("width", function(id, oldval, newval){this.buttonFrame.width = newval; this.center.width = newval - 10; this.right.hOffset = newval - 5; this.labelText.hOffset = this.buttonFrame.width / 2; return newval;})
	this.watch("vOffset", function(id, oldval, newval){this.buttonFrame.vOffset = newval; return newval;})
	this.watch("hOffset", function(id, oldval, newval){this.buttonFrame.hOffset = newval; return newval;})
	this.watch("visible", function(id, oldval, newval){this.buttonFrame.visible = newval; return newval;})
	this.watch("label", function(id, oldval, newval){this.labelText.data = newval; return newval;})
}