function WindowObject(){
	this.windowObject = new Window();
/*========================================================================================*/
/*                               Default Values                                           */
/*========================================================================================*/
	
	
	this.title = ""; //sets the title for this window
	this.width = 100; //the width of the window
	this.height = 100; //the height of the window
	this.vOffset = this.windowObject.vOffset; //the vOffset of the window
	this.hOffset = this.windowObject.vOffset; //the hOffset of the window
	this.visible = 0; //the visibility of the window
	this.shadow = 0; //display a windows shadow

	this.resizeable = 1; //wether or not to allow user resizing

	this.minimumHsize = 60;
	this.minimumVsize = 60;
	
	this.oofdim = 1;// dims the window when the window loses focus
	
	this.closesWidget = 0; //close the widget when this window is closed?

	this.bgColor = "#999999"; //the background color of the main window area


	this.scrollbar = 1; //sets the main windwos scrollbar visibility
	this.scrollbarAutohide = 0; //turns on and off the main windows scrollbar autohide. 
	
	this.imageSrc = "Objects/WindowObject";


/*========================================================================================*/
/*        Do Not change anything after this line unless you know what you are doing       */
/*========================================================================================*/

	this.windowObject.parent = this;
	this.windowObject.onLoseFocus = function(){if (this.parent.oofdim ==1){this.opacity = 175;}}
	this.windowObject.onGainFocus = function(){this.opacity = 255;}

	this.windowObject.width = this.width;
	this.windowObject.height = this.height;
	this.windowObject.visible = this.visible;
	
	this.titlebar = new Array();
	this.titlebar.parent = this;
	this.titlebar.ulimage = new Image();
	this.titlebar.ulimage.src = this.imageSrc + "/ulimage.png";
	this.titlebar.ulimage.window = this.windowObject;
	this.titlebar.ulimage.visible = 1;
	this.titlebar.ulimage.vOffset = 0;
	this.titlebar.ulimage.hOffset = 0;
	this.titlebar.ulimage.width = 20;
	this.titlebar.ulimage.height = 20;
	this.titlebar.ulimage.zOrder = 2;
	this.titlebar.ulimage.parent = this.titlebar;
		
	this.titlebar.urimage = new Image();
	this.titlebar.urimage.src = this.imageSrc + "/urimage.png";
	this.titlebar.urimage.window = this.windowObject;
	this.titlebar.urimage.visible = 1;
	this.titlebar.urimage.vOffset = 0;
	this.titlebar.urimage.hOffset = this.windowObject.width - 20;
	this.titlebar.urimage.width = 20;
	this.titlebar.urimage.height = 20;
	this.titlebar.urimage.zOrder = 2;
	this.titlebar.urimage.parent = this.titlebar;

	this.titlebar.cimage = new Image();
	this.titlebar.cimage.src = this.imageSrc + "/cimage.png";
	this.titlebar.cimage.window = this.windowObject;
	this.titlebar.cimage.visible = 1;
	this.titlebar.cimage.vOffset = 0;
	this.titlebar.cimage.hOffset = 20;
	this.titlebar.cimage.width = this.windowObject.width - 40;
	this.titlebar.cimage.height = 20;
	this.titlebar.cimage.zOrder = 0;
	this.titlebar.cimage.parent = this.titlebar;

	this.titlebar.close = new Image();
	this.titlebar.close.src = this.imageSrc + "/close.png";
	this.titlebar.close.height = 18;
	this.titlebar.close.width = 18;
	this.titlebar.close.visible = 1;
	this.titlebar.close.vOffset = 3;
	this.titlebar.close.hOffset = 3;
	this.titlebar.close.zOrder = 3;
	this.titlebar.close.window = this.windowObject;
	this.titlebar.close.parent = this.titlebar;
	this.titlebar.close.onMouseEnter = function(){this.src = this.parent.parent.imageSrc + "/closeon.png";}
	this.titlebar.close.onMouseExit = function(){this.src = this.parent.parent.imageSrc + "/close.png";}
	this.titlebar.close.onMouseDown = function(){this.src = this.parent.parent.imageSrc + "/closeclicked.png";}
	this.titlebar.close.onMouseUp = function(){this.src = this.parent.parent.imageSrc + "/closeon.png"; this.parent.parent.visible = 0; if (this.parent.parent.closesWidget == 1){closeWidget();}}

	this.titlebar.title = new Text();
	this.titlebar.title.editable = 0;
	this.titlebar.title.visible = 1;
	this.titlebar.title.font = "Verdana";
	this.titlebar.title.size = 13;
	this.titlebar.title.color = "#000000";
	this.titlebar.title.data = this.title;
	this.titlebar.title.alignment = "center";
	this.titlebar.title.hOffset = this.windowObject.width / 2
	this.titlebar.title.vOffset = this.titlebar.title.size +2;
	this.titlebar.title.height = 16
	this.titlebar.title.zOrder = 1;
	this.titlebar.title.window = this.windowObject;
	this.titlebar.title.scrollbar = 0;
	this.titlebar.title.parent = this.titlebar;
	
	this.contentBackground = new Image();
	this.contentBackground.src = this.imageSrc + "/windowbg.png";
	this.contentBackground.parent = this;
	this.contentBackground.window = this.windowObject;
	this.contentBackground.height = this.windowObject.height - 25;
	this.contentBackground.width = this.windowObject.width - 10;
	this.contentBackground.vOffset = 20;
	this.contentBackground.hOffset = 5;
	this.contentBackground.colorize = this.bgColor;
	this.contentBackground.visible = 1;

//	this.contentBackground.bgOpacity = this.bgOpacity;
//	this.contentBackground.scrollbar = 0;
//	this.contentBackground.editable = 0;

	this.leftEdge = new Image();
	this.leftEdge.parent = this;
	this.leftEdge.window = this.windowObject;
	this.leftEdge.src = this.imageSrc + "/leftedge.png";
	this.leftEdge.height = this.windowObject.height - 25;
	this.leftEdge.width = 5;
	this.leftEdge.vOffset = 20;
	this.leftEdge.hOffset = 0;
	this.leftEdge.visible = 1;

	this.rightEdge = new Image();
	this.rightEdge.parent = this;
	this.rightEdge.window = this.windowObject;
	this.rightEdge.src = this.imageSrc + "/rightedge.png";
	this.rightEdge.height = this.windowObject.height - 25;
	this.rightEdge.width = 5;
	this.rightEdge.vOffset = 20;
	this.rightEdge.hOffset = this.windowObject.width - 5;
	this.rightEdge.visible = 1;
	this.rightEdge.onMouseMove = function(){if (this.parent.resizeable == 1){if (system.event.hOffset >= this.parent.minimumHsize){this.parent.width = system.event.hOffset; }}}

	this.bottomEdge = new Image();
	this.bottomEdge.parent = this;
	this.bottomEdge.window = this.windowObject;	
	this.bottomEdge.src = this.imageSrc + "/bottomedge.png";
	this.bottomEdge.height = 5;
	this.bottomEdge.width = this.windowObject.width;
	this.bottomEdge.vOffset = this.windowObject.height - 5;
	this.bottomEdge.hOffset = 0;
	this.bottomEdge.visible = 1;
	this.bottomEdge.onMouseMove = function(){if (this.parent.resizeable == 1){if (system.event.vOffset >= this.parent.minimumVsize){this.parent.height = system.event.vOffset;}}}

	this.lrimage = new Image();
	this.lrimage.parent = this;
	this.lrimage.window = this.windowObject;
	this.lrimage.src = this.imageSrc + "/lrimage.png";
	this.lrimage.width = 14;
	this.lrimage.height = 14;
	this.lrimage.vOffset = this.windowObject.height - 14;
	this.lrimage.hOffset = this.windowObject.width - 14;
	this.lrimage.onMouseMove = function(){if (this.parent.resizeable == 1){if (system.event.hOffset >= this.parent.minimumHsize){this.parent.width = system.event.hOffset; } if (system.event.vOffset >= this.parent.minimumVsize){this.parent.height = system.event.vOffset; }}};

	this.contentFrame = new Frame();
	this.contentFrame.window = this.windowObject;
	this.contentFrame.width = this.windowObject.width - 30;
	this.contentFrame.height = this.windowObject.height - 25;
	this.contentFrame.vOffset = 20;
	this.contentFrame.hOffset = 5;
	this.contentFrame.visible = 1;	
	
	this.frameScrollbar = new ScrollBar();
	this.frameScrollbar.window = this.windowObject;
	this.frameScrollbar.height = this.contentFrame.height - 2;
	this.frameScrollbar.width  = 20; 
	this.frameScrollbar.visible = this.scrollbar;
	this.frameScrollbar.autoHide = this.scrollbarAutohide;
	this.frameScrollbar.vOffset = 21;
	this.frameScrollbar.hOffset = this.windowObject.width - 23;
	this.frameScrollbar.parent = this;
	this.contentFrame.vScrollBar = this.frameScrollbar;
	
	this.watch("title", function(id, oldval, newval){this.titlebar.title.data = newval; return newval;});
	this.watch("width", function(id, oldval, newval){this.windowObject.width = newval; this.titlebar.title.hOffset = newval / 2; this.titlebar.urimage.hOffset = newval - 20; this.titlebar.cimage.width = newval - 40; this.contentFrame.width = newval - 30; this.contentBackground.width = newval - 10; this.frameScrollbar.hOffset = newval - 25; this.bottomEdge.width = newval; this.rightEdge.hOffset = newval - 5; this.lrimage.hOffset = newval-14; if (this.frameScrollbar.visible == 1){this.contentFrame.width -= this.frameScrollbar.width} else if (this.frameScrollbar.visible == 0){this.contentFrame.width += this.frameScrollbar.width}; return newval;});
	this.watch("height", function(id, oldval, newval){this.windowObject.height = newval; this.contentFrame.height = newval - 25; this.contentBackground.height = newval - 25; this.frameScrollbar.height = newval - 27; this.leftEdge.height = newval - 25; this.rightEdge.height = newval - 25; this.bottomEdge.vOffset = newval - 5; this.lrimage.vOffset = newval - 14; return newval;});
	this.watch("vOffset", function(id, oldval, newval){this.windowObject.vOffset = newval; return newval;});
	this.watch("hOffset", function(id, oldval, newval){this.windowObject.hOffset = newval; return newval;});
	this.watch("visible", function(id, oldval, newval){this.windowObject.visible = newval; return newval;});
	this.watch("bgColor", function(id, oldval, newval){this.contentBackground.bgColor = newval; return newval;});
	this.watch("bgOpacity", function(id, oldval, newval){this.contentBackground.bgOpacity = newval; return newval;});
	this.watch("scrollbar", function(id, oldval, newval){this.frameScrollbar.visible = newval; if (newval == 1){this.contentFrame.width = this.width - 30;} else if (newval == 0){this.contentFrame.width = this.width-10}; return newval;});
	this.watch("scrollbarAutohide", function(id, oldval, newval){this.frameScrollbar.autoHide = newval; return newval;});
	this.watch("shadow", function(id, oldval, newval){this.windowObject.shadow = newval; return newval;});
	
}