function initialize(){
	mainWindow = new WindowObject();
	mainWindow.title = "iTags";
	mainWindow.height = 140;
	mainWindow.width = 400;
	mainWindow.scrollbar = 0;
	mainWindow.closesWidget = 1;
	mainWindow.oofdim = 0;
	
	mainWindow.contentFrame.selectFileButton = new Button();
	mainWindow.contentFrame.selectFileButton.label = "Create/Edit Tags";
	mainWindow.contentFrame.selectFileButton.width = 115;
	mainWindow.contentFrame.selectFileButton.onMouseUp = function(){showForm();}
	mainWindow.contentFrame.selectFileButton.visible = 1;
	mainWindow.contentFrame.selectFileButton.attach(mainWindow.contentFrame);
	
	mainWindow.contentFrame.fileDrop = new TextArea();
	mainWindow.contentFrame.fileDrop.data = "";
	mainWindow.contentFrame.fileDrop.width = 385;
	mainWindow.contentFrame.fileDrop.height = 80;
	mainWindow.contentFrame.fileDrop.vOffset = 30;
	mainWindow.contentFrame.fileDrop.hOffset = 0;
	mainWindow.contentFrame.fileDrop.editable = 1;
	mainWindow.contentFrame.fileDrop.scrollbar = 1;
	mainWindow.contentFrame.fileDrop.bgColor = "#00FF00";
	mainWindow.contentFrame.fileDrop.bgOpacity = 0;
	mainWindow.contentFrame.addSubview(mainWindow.contentFrame.fileDrop);
	mainWindow.contentFrame.fileDrop.visible = 1;
	
	mainWindow.contentFrame.dropFileButton = new Button();
	mainWindow.contentFrame.dropFileButton.label = "Drop Files Here";
	mainWindow.contentFrame.dropFileButton.width = 115;
	mainWindow.contentFrame.dropFileButton.hOffset = 135;
	mainWindow.contentFrame.dropFileButton.visible = 1;
	mainWindow.contentFrame.dropFileButton.attach(mainWindow.contentFrame);
	mainWindow.contentFrame.dropFileButton.onDragDrop = function (){

		if (system.event.data[0] == "filenames"){
			files = system.event.data;
			files.shift();
			
			for (items in files){
				mainWindow.contentFrame.fileDrop.data += "\n"+files[items];
			}
		}
	}	
	
	mainWindow.contentFrame.clearFileButton = new Button();
	mainWindow.contentFrame.clearFileButton.label = "Clear All Files";
	mainWindow.contentFrame.clearFileButton.width = 115;
	mainWindow.contentFrame.clearFileButton.hOffset = 270;
	mainWindow.contentFrame.clearFileButton.visible = 1;
	mainWindow.contentFrame.clearFileButton.onMouseUp = function(){mainWindow.contentFrame.fileDrop.data = "";}
	mainWindow.contentFrame.clearFileButton.attach(mainWindow.contentFrame);
	
	mainWindow.MenuItems = new Array();
		addAboutMenuItem(mainWindow.MenuItems);
		addDonateMenuItem(mainWindow.MenuItems);
		addLicenseMenuItem(mainWindow.MenuItems);
		addReportBugMenuItem(mainWindow.MenuItems);
	mainWindow.windowObject.contextMenuItems = mainWindow.MenuItems;
	
	mainWindow.visible = 1;
}

function showForm(retryEdit){
	if ((!retryEdit)
	   &&(preferences.setDefault.value != 1)){
		clearPreferences();		
	}

	showWidgetPreferences();
	//if all preferences are still empty (user clicked cancel), do not process
	if (
		(preferences.title.value == "") &&
		(preferences.artist.value == "") &&
		(preferences.albumArtist.value == "") &&
		(preferences.album.value == "") &&
		(preferences.grouping.value == "") &&
		(preferences.composer.value == "") &&
		(preferences.year.value == "") &&
		(preferences.copyright.value == "") &&
		(preferences.comments.value == "") &&
		(preferences.genre.value == "") &&
		(preferences.trackNumber.value == "") &&
		(preferences.totalTracks.value == "") &&
		(preferences.diskNumber.value == "") &&
		(preferences.totalDisks.value == "") &&
		(preferences.bpm.value == "") &&
		(preferences.compilation.value == "Unchanged") &&
		(preferences.gapless.value == "Unchanged") &&
		(preferences.advisory.value == "Unchanged") &&
		(preferences.fileType.value == "Unchanged") &&
		(preferences.encodingTool.value == "") &&
		(preferences.show.value == "") &&
		(preferences.seasonNumber.value == "") &&
		(preferences.episodeID.value == "") &&
		(preferences.episodeNumber.value == "") &&
		(preferences.tvNetwork.value == "") &&
		(preferences.description.value == "") &&
		(preferences.podcastFlag.value == "Unchanged") &&
		(preferences.podcastKeyword.value == "") &&
		(preferences.podcastURL.value == "") &&
		(preferences.podcastGUID.value == "") &&
		(preferences.artwork.value == "")){
		//skip processing here
		//intentionally doing nothing, since nothing was changed. 
		print("doing nothing");
	} else {
		if (preferences.cancel.value == 1){
			//reset cancel flag and skip processing
			preferences.cancel.value == 0;
			savePreferences();
		} else if (((preferences.totalTracks.value != "") && (preferences.trackNumber.value == "")) || ((preferences.totalDisks.value != "")&&(preferences.diskNumber.value == ""))){
			alert("If you choose to set a total number of tracks or discs,\n you must also set the individal track or disc number.\n Please either remove your settings for the total discs/tracks or add a current disc/track number.\n\nIf you wish to cancel editing these tags, go to the Optional Flags tab, and click the cancel editing checkbox, then Click Ok!!!");
			showForm(1);
		} else {
			processFiles();			
		}
	}
	

}

function clearPreferences(){
	preferences.title.value = "";
	preferences.artist.value = "";
	preferences.albumArtist.value = "";
	preferences.album.value = "";
	preferences.grouping.value = "";
	preferences.composer.value = "";
	preferences.year.value = "";
	preferences.copyright.value = "";
	preferences.comments.value = "";
	preferences.genre.value = "";
	preferences.trackNumber.value = "";
	preferences.totalTracks.value = "";
	preferences.diskNumber.value = "";
	preferences.totalDisks.value = "";
	preferences.bpm.value = "";
	preferences.compilation.value = "Unchanged";
	preferences.gapless.value = "Unchanged";
	preferences.advisory.value = "Unchanged";
	preferences.fileType.value = "Unchanged";
	preferences.encodingTool.value = "";
	preferences.show.value = "";
	preferences.seasonNumber.value = "";
	preferences.episodeID.value = "";
	preferences.episodeNumber.value = "";
	preferences.tvNetwork.value = "";
	preferences.description.value = "";
	preferences.podcastFlag.value = "Unchanged";
	preferences.podcastKeyword.value = "";
	preferences.podcastURL.value = "";
	preferences.podcastGUID.value = "";
	preferences.cancel.value = 0;
	preferences.artwork.value = "";

	savePreferences();
}

function processFiles(){
	
	selectedFiles = new Array();
	selectedFiles = mainWindow.contentFrame.fileDrop.data.split("\n");
	if (selectedFiles[0] == "Drop Files Here"){selectedFiles.shift();}
	
	commandLine = ""
	
	processingWindow = new WindowObject();
	processingWindow.title = "Processing Files";
	processingWindow.width = 200;
	processingWindow.height = 200;
	processingWindow.scrollbar = 0;
	processingWindow.closesWidget = 0;
	processingWindow.oofDim = 0;
	processingWindow.visible = 1;
	processingWindow.windowObject.focus();

	processingWindow.contentFrame.readout = new TextArea();
	processingWindow.contentFrame.readout.data = "Processing Files...\nPlease Wait...";
	processingWindow.contentFrame.readout.editable = 0;
	processingWindow.contentFrame.readout.width = 185;
	processingWindow.contentFrame.readout.height = 170;
	processingWindow.contentFrame.readout.visible = 1;
	processingWindow.contentFrame.addSubview(processingWindow.contentFrame.readout);

	for (items in preferences){
		
		if ((items != "lockWindowPosition")&&
		    (items != "cancel")&&
		    (items != "windowOpacity")&&
		    (items != "windowLevel")&&
		    (items != "closeWhenComplete")&&
		    (items != "replaceOriginal")){
			eval("preferences."+items+".value = preferences."+items+".value.replace(/\"/g, \"\\\\\\\"\")");
		}
		
		if ((preferences.trackNumber.value != "")&&(items == "trackNumber")){
			if (preferences.totalTracks.value == ""){
				commandLine += " " + preferences.trackNumber.parameter + " " + preferences.trackNumber.value;
			} else {
				commandLine += " " + preferences.trackNumber.parameter + " " + preferences.trackNumber.value +"/" + preferences.totalTracks.value;
			}
		} else if ((preferences.diskNumber.value != "")&&(items == "diskNumber")){
			if (preferences.totalDisks.value == ""){
				commandLine += " " + preferences.diskNumber.parameter + " " + preferences.diskNumber.value;
			} else {
				commandLine += " " + preferences.diskNumber.parameter + " " + preferences.diskNumber.value +"/" + preferences.totalDisks.value;
			}
		} else if ((items == "totalDisks") || (items == "totalTracks")){
			//do nothing, as these cases are handled above
		} else if ((items == "lockWindowPosition")||(items=="cancel")||(items=="windowOpacity")||(items=="windowLevel")||(items=="closeWhenComplete")||(items=="replaceOriginal")){
			//do nothing, as these are not tag preference values
		} else if ((items == "artwork") && (preferences.artwork.value != "")){
			commandLine += " " + preferences.artwork.parameter + " \"" + convertPathToPlatform(preferences.artwork.value)+"\"";
		} else {
			eval("if(preferences."+items+".value == \"Unchanged\"){preferences."+items+".value = \"\"}");
			eval("if((preferences."+items+".value == \" \")||(preferences."+items+".value == \"Remove\")){commandLine += \" \" + preferences."+items+".parameter + \" \" +\"\\\"\\\"\"; preferences."+items+".value = \"\";}");
			eval("if(preferences."+items+".value == \"Yes\"){preferences."+items+".value == \"true\"}");
			eval("if(preferences."+items+".value == \"No\"){preferences."+items+".value == \"false\"}");
			eval("if(preferences."+items+".value != \"\"){commandLine += \" \" + preferences."+items+".parameter + \" \" + \"\\\"\" + preferences."+items+".value + \"\\\"\"}");
		}

	}
print(commandLine);
	
	if (preferences.replaceOriginal.value == 1){commandLine += " -W";}
	tempFiles = new Array();
	for (items in selectedFiles){
		if (selectedFiles[items] != ""){//make sure line isnt blank
			tempFiles.push(selectedFiles[items]);
		}
	}
	selectedFiles = tempFiles;
	for (items in selectedFiles){

		processingWindow.contentFrame.readout.data += "\nProcessing "+Number(Number(items)+1)+" of "+selectedFiles.length;
		updateNow();
		sleep(50);
	
		if (system.platform == "macintosh"){
			selectedFiles[items] = selectedFiles[items].replace(/\"/g, "\\\"");
			selectedFiles[items] = selectedFiles[items].replace(/\'/g, "\\\'");
//			print(runCommand("export AP_PADDING=\"DEFAULT_PAD=5000\""));
			if (!runCommand("AtomicParsley/OSX/AtomicParsley "+convertPathToPlatform(selectedFiles[items]).replace(/ /g, '\\ ')+" -T").match(/bad mpeg4 file/)){
				progressTimer.ticking = 1;
				print(runCommand("AtomicParsley/OSX/AtomicParsley "+convertPathToPlatform(selectedFiles[items]).replace(/ /g, '\\ ')+commandLine));
				progressTimer.ticking = 0;
			} else {
				processingWindow.contentFrame.readout.data += "\nThis file does not appear to be a valid media file";
			}
		} else {
			if (!runCommand("AtomicParsley/win32/AtomicParsley.exe \""+convertPathToPlatform(selectedFiles[items])+"\" -T").match(/bad mpeg4 file/)){
				progressTimer.ticking = 1;
				print(runCommand("AtomicParsley/win32/AtomicParsley.exe \""+convertPathToPlatform(selectedFiles[items])+"\""+commandLine));			
				progressTimer.ticking = 0;
			} else {
				processingWindow.contentFrame.readout.data += "\nThis file does not appear to be a valid mpeg file";
			}
		}
	}
		
	processingWindow.contentFrame.readout.data +="\nDONE!";

	if (preferences.closeWhenComplete.value == 1){processingWindow.visible = 0;}
	if (preferences.clearFiles.value == 1){mainWindow.contentFrame.clearFileButton.onMouseUp();}
}

progressTimer = new Timer();
progressTimer.ticking = 0;
progressTimer.interval = 1;
progressTimer.onTimerFired = function(){processingWindow.contentFrame.readout.data += ".";}

function setParameters(){
	
	preferences.title.parameter = "--title";
	preferences.artist.parameter = "--artist";
	preferences.albumArtist.parameter = "--albumArtist";
	preferences.album.parameter = "--album";
	preferences.grouping.parameter = "--grouping";
	preferences.composer.parameter = "--composer";
	preferences.year.parameter = "--year";
	preferences.copyright.parameter = "--copyright";
	preferences.comments.parameter = "--comments";
	preferences.genre.parameter = "--genre";
	preferences.trackNumber.parameter = "--tracknum";
	preferences.totalTracks.parameter = "";
	preferences.diskNumber.parameter = "--disk";
	preferences.totalDisks.parameter = "";
	preferences.bpm.parameter = "--bpm";
	preferences.compilation.parameter = "--compilation";
	preferences.gapless.parameter = "--gapless";
	preferences.advisory.parameter = "--advisory";
	preferences.fileType.parameter = "--stik";
	preferences.encodingTool.parameter = "--encodingTool";
	preferences.show.parameter = "--TVShowName";
	preferences.seasonNumber.parameter = "--TVSeasonNum";
	preferences.episodeID.parameter = "--TVEpisode";
	preferences.episodeNumber.parameter = "--TVEpisodeNum";
	preferences.tvNetwork.parameter = "--TVNetwork";""
	preferences.description.parameter = "--description";
	preferences.podcastFlag.parameter = "--podcastFlag";
	preferences.podcastCategory.parameter = "--podcastCategory";
	preferences.podcastKeyword.parameter = "--podcastKeyword";
	preferences.podcastURL.parameter = "--podcastURL";
	preferences.podcastGUID.parameter = "--podcastGUID";
	preferences.artwork.parameter = "--artwork";
		
}

checkForUpdates();
setParameters();
initialize();
focusWidget();
